c23456789012345678901234567890123456789012345678901234567890123456789012
       PROGRAM NUSSELT1
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (NPMAX=5000,NMAX=50,NXMAX=500,NMAXEIG=400)
        COMMON /DADOS1/ NEIGEN,EV(NMAXEIG),UNU,APTT,K,NFLOW
        COMMON /DADOS2/ BNUM1,BDEN1,BTERM
	   REAL*8 EV(NMAXEIG),UNU,APTT,xlow,xhigh,BNUM1,BDEN1,BTERM
	   REAL*8 rr(NPMAX+1),yfinal(NPMAX+1,NMAX),r(NPMAX+1)
c	   REAL*8 yprime(NPMAX+1,NMAX),ywallpr(NMAX,NMAXEIG)
	   REAL*8 y2(NMAXEIG,NPMAX+1),y22(NMAXEIG,NPMAX+1)
	   REAL*8 ywall(NMAX,NMAXEIG),ANUAVE(NXMAX)
	   REAL*8 ANUSSEL(NXMAX),x(NXMAX),xprime(NXMAX)
	   REAL*8 TETA(NPMAX+1,NXMAX),SUMTET(NPMAX+1),THETAM(NXMAX)
	   REAL*8 AINTEGR(NMAXEIG),h,DELTAX,BR(40)
	   REAL*8 FUNNU(NPMAX+1),SMALLDX
	   REAL*8 AUX1,AUX2,ANUM1,ADEN1,SUMNUM,SUMDEN,AUX3(NPMAX+1)
	   REAL*8 AUX4(NXMAX),AUX5,AUX6,AUX7,AUX8(NPMAX+1),SMALL
	   INTEGER npoints,nfun,NEIGEN,IFLAG(NMAXEIG),NFLOW,NBR,IBOUND
	   INTEGER NXS,IFLAGBR
	   LOGICAL SUCC(NPMAX+1)
           CHARACTER*50 TITLE,TITLE2			!I added for comments
c   This code reads the output of previous programs sledge and rungekutta3.6.f 
c   and calculates the Nusselt number and the temperature profile

c   In version nusselt1.93 the calculation of the average Nusselt number
c   has been included but only for Twall. The calculation of the average
c   Nusselt number is by 
c   Version nusselt1.6 does not calculate the average Nusselt number 

c    21st December 2001

c   Input of data from previous data files
       SMALL=1.D-30
       SMALLDX=1.D-2

       OPEN(7,FILE='rungein.dat')
       REWIND 7
       READ(7,*) TITLE2
       READ(7,*) nfun			!number of functions
       READ(7,*) h,ndata		!step size, number of radial points used for all calculations
       CLOSE(7)

       OPEN(10,FILE='sledout.dat',STATUS='OLD')
       REWIND 10
        READ(10,*)TITLE		!any comment
	READ(10,*)NFLOW,UNU,APTT,NEIGEN,IBOUND	!reads n, UN/U, a, number of eigen functions

       DO 30 I = 1,NEIGEN
         READ (10,12) Ilixo,EV(I),IFLAG(I)
   30  CONTINUE
   12    FORMAT(I6,2X,D25.15,2X,I3)				!Format for printout in file
   
       CLOSE(10)

        OPEN(15,FILE='brinkx.dat',STATUS='OLD')
	REWIND 15
	READ(15,*)NBR					!number of Brinkman numbers
	DO I=1,NBR
	   READ(15,*) BR(I)
	END DO
	READ(15,*)NXS,DELTAX
	READ(15,*)npoints			!number of radial points we wish to calculate and output.
c    ndata must be a multiple of npoints otherwise there will be problems.
	CLOSE(15)
	
        IF (DELTAX .GT. 0.0) THEN
c   Define the coordinates x (axial coordinates). Linear variation
         xprime(1)=0.0			!this is x'
         x(1)=0.0			!this is x*
	 DO I=2,NXS
	   xprime(I)=xprime(I-1)+DELTAX			!This is x'.It must be converted into x*
	   x(I)=xprime(I)*4.*(2.-NFLOW)*(2.-NFLOW)	!Converting x' (variable xprime) into x* (variable x)
	 END DO
c   End of coordinate x generation if linear

        ELSE IF (DELTAX .LT. 0.0) THEN	!This part is wrong
c   Define the coordinates x (axial coordinates). logarithmic variation
         xprime(1)=1.0D-06			!this is x'
         x(1)=xprime(1)*4.*(2.-NFLOW)*(2.-NFLOW)			!this is x*
	 DO I=2,NXS
	   AI=I
	   AB=DMOD(AI,1.0D+01)
	   AA=DINT(AI/1.0D+01)
	   AC=DLOG10(AA+AB)
	   IF (AA+AB .GT. 10) THEN
	     AD=DMOD(AA+AB,1.0D+01)
	     AC=DLOG10(AD+(1.0D+00))
	     AA=AA+1.0D+00
	   END IF
	   xprime(I)=xprime(1)*(1.0D+01)**(AC+AA)			!This is x'.It must be converted into x*
	   x(I)=xprime(I)*4.*(2.-NFLOW)*(2.-NFLOW)	!Converting x' (variable xprime) into x* (variable x)
	 END DO
c   End of coordinate x generation if logarithmic
        ENDIF

        OPEN(22,FILE='rungeoutput.dat',STATUS='OLD')		!formatted for further use by nusselt.f
	REWIND 22
	READ(22,*)TITLE2
	
        DO 20 K=1,NEIGEN
          READ(22,*)Ilixo,EV(k)					!formatted for further use
	     DO J=1,nfun
              IF (J .EQ. 2) THEN				!formmated for further use
                DO I=0,ndata					!formmated for further use
                  READ(22,50)II,rr(I+1),yfinal(I+1,J)		 	!formmated for further use	   
                  y22(k,I+1)=yfinal(I+1,J)
                END DO	   					!formmated for further use
              ENDIF						!formmated for further use
          I=npoints
c              READ(22,50)II,rr(I+1),yfinal(I+1,J),yprime(I+1,J) 	!formatted for further use   
              READ(22,50)II,rr(I+1),yfinal(I+1,J) 		!formatted for further use   
              ywall(J,k)=yfinal(I+1,J)				!functions yis at wall for each eigenvalue
c	      ywallpr(J,k)=yprime(I+1,J)				!derivatives yis at wall for each eigenvalue
	     END DO
	  READ(22,*) AINTEGR(k)
 20     CONTINUE

	CLOSE(22)

c   End of data input

c   Now preparing function y2 to include only the data at npoints
        ifactor=ndata/npoints
        DO K=1,NEIGEN
	 DO I=0,npoints
	  II=ifactor*I
	  y2(k,I+1)=y22(k,II+1)
	  r(I+1)=rr(II+1)
	 END DO
	END DO

c   End

c   Just opening the files for output (to open only once)

        OPEN(16,FILE='nusselt.dat')
	REWIND 16
	WRITE(16,*)'APTT = ',APTT,'NFLOW= ',NFLOW

	OPEN(17,FILE='tempera.dat')
	REWIND 17
	WRITE(17,*)'APTT = ',APTT,'NFLOW= ',NFLOW

c   Now, let's start the calculations (Do one calculation for each Brinkman number)
        AUX1=24.*(54.*APTT*APTT+110.*APTT+55.)/1925.*(1.-NFLOW)
	AUX2=(280.*APTT*APTT+504.*APTT+225.)*NFLOW/270.
        DO 130 IBR=1,NBR
	IF (IBOUND .EQ. 1) THEN				!IBOUND=1 is Twall constant
	   AUX5=(2.**(2.+NFLOW)*6.*APTT+(5.+4.*NFLOW)*4.)*3./(20.+
     *       7.*NFLOW)*BR(IBR)*UNU*UNU				!for THETAM
	   ANUM1=-(3.+NFLOW)*BR(IBR)*UNU		!For Nu
	   ADEN1=-(AUX1+AUX2)*BR(IBR)*UNU*UNU*UNU	!For Nu
	   
	   DO 45 II=1,npoints+1							!For temperature
           AUX3(II)=1.-(2.**(2.+NFLOW)*APTT*(r(II)**6-1.)+(5.+4.*NFLOW)*	!For temperature
     *       (r(II)**4-1.))*3./(20.+7.*NFLOW)*BR(IBR)*UNU*UNU			!For temperature				
 45        CONTINUE								!For temperature
 
           DO 40 I=1,NXS
	     SUMNUM=0.			!for the Nusselt number
	     SUMDEN=0.			!for the Nusselt number  
             DO II=1,npoints+1
	       SUMTET(II)=0.		!for temperature
	     END DO
	     DO 35 k=1,NEIGEN
	       SUMNUM=SUMNUM+EXP(-EV(k)*EV(k)*x(I))/EV(k)/ywall(4,k)*			!For Nusselt
     *          (ywall(1,k)-(3.+NFLOW)*(3.+NFLOW)*BR(IBR)*AINTEGR(k))			!For Nusselt
               SUMDEN=SUMDEN+EXP(-EV(k)*EV(k)*x(I))/EV(k)**3/ywall(4,k)*		!For Nusselt
     *          (NFLOW+1.)*(ywall(1,k)-(3.+NFLOW)*(3.+NFLOW)*BR(IBR)*			!For Nusselt
     *          AINTEGR(k))								!For Nusselt
               DO II=1,npoints+1		!For temperature
	         SUMTET(II)=SUMTET(II)+EXP(-EV(k)*EV(k)*x(I))/EV(k)/
     *            ywall(4,k)/ywall(1,k)*y2(k,II)*(ywall(1,k)-(3.+NFLOW)*	!For temperature
     *            (3.+NFLOW)*BR(IBR)*AINTEGR(k))				!For temperature						
               END DO
 35          CONTINUE
            ANUSSEL(I)=(ANUM1+2.*SUMNUM)/(ADEN1+2.*SUMDEN)*2.*(2.-NFLOW)
            THETAM(I)=(-AUX5+2.*SUMNUM)/ANUSSEL(I)*2.*(2.-NFLOW)
              DO II=1,npoints+1
                TETA(II,I)=AUX3(II)+2.*SUMTET(II)
	      END DO
	    
c      Here comes the calculation of the average Nusselt for Twall=constant
              BNUM1=2.*BR(IBR)*UNU*(NFLOW-2.)*(NFLOW+3.)
	      BDEN1=-THETAM(I)
	      BTERM=4.*xprime(I)
	      IFLAGBR=0		!Flag for incorrect bracketing.Unknown for the moment
	       xlow=1.0D-6	!guessed range low
	       xhigh=1.0	!guessed range high
	      
 41	      CALL myzbrac(xlow,xhigh,SUCC(I))	!for bracketing solution

            IF (SUCC(I) .eq. .FALSE.) THEN
	       xlow=-1.0D-6	!guessed range low
	       xhigh=-1.	!guessed range high
	       IFLAGBR=IFLAGBR+1
	       IF (IFLAGBR .GT. 3) GOTO 40
	       GOTO 41
	    ENDIF

	      ANUAVE(I)=rtbis(xlow,xhigh,1.0D-8)
c	      ANUAVE(I)=zriddr(xlow,xhigh,1.0D-8)
c	      ANUAVE(I)=rtflsp(xlow,xhigh,1.0D-8)
	      FUNNU(I)=func(ANUAVE(I))		!calculates F(Nu) for checking   

c      Here end the calculation of the average Nusselt for Twall=constant

 40        CONTINUE	

	ELSE IF (IBOUND .EQ. 0) THEN		!IBOUND=0 is wall heat flux constant

          n=1-NFLOW
	  AUX1=UNU*UNU*(NFLOW*(19./54.*APTT*APTT+17./30.*APTT+11./48.)+			!For Nusselt
     *      n*(303./1925.*APTT*APTT+29./105.*APTT+17./140.))				!For Nusselt
          AUX2=BR(IBR)*UNU*UNU*UNU*(NFLOW/UNU/UNU+n*(468./385.*APTT*			!For Nusselt
     *      APTT+68./35.*APTT+27./35.))							!For Nusselt
          AUX5=NFLOW/2160.*(760.*APTT*APTT+1224.*APTT+495.)+n/23100.*		!For temperature
     *      (3636.*APTT*APTT+6380.*APTT+2805.)					!For temperature
	  AUX5=UNU*UNU*AUX5							!For temperature
          AUX6=UNU*(NFLOW+1.)/2./(2.-NFLOW)/72./(5./9.)**n			!For temperature
          AUX7=BR(IBR)*UNU**3*(280.*(162./35.)**n*APTT*APTT+504.*(110./		!For temperature
     *      21.)**n*APTT+225.*(88./15.)**n)/270./(385./54.)**NFLOW		!For temperature
          DO II=1,npoints+1							!For temperature
	    AUX3(II)=(r(II)**6-9.*(5./3.)**n*r(II)*r(II)+8.*(7./4.)**n)*	!For temperature
     *        2.**(NFLOW+1.)*APTT+9.*(5./9.)**n*(r(II)**4-4.*1.5**n*		!For temperature
     *        r(II)*r(II)+3.*(5./3.)**n)					!For temperature
	    AUX3(II)=AUX5-AUX6*AUX3(II)
	    AUX8(II)=(3.+NFLOW)*BR(IBR)*UNU*2.*(2.-NFLOW)*AUX3(II)-AUX7-
     *        BR(IBR)*UNU*UNU*(2.**(NFLOW+2.)*APTT*(r(II)**6-1.)+(5.+4.*
     *        NFLOW)*(r(II)**4-1.))*3./(20.+7.*NFLOW)
	  END DO
          DO 60 I=1,NXS
	   SUMNUM=0.									!For Nusselt
           AUX4(I)=(NFLOW+1.)*x(I)*(1./2./(2.-NFLOW)+(3.+NFLOW)*BR(IBR)*
     *       UNU)
           DO II=1,npoints+1							!for temperature
	     SUMTET(II)=0.							!for temperature
	   END DO								!for temperature
	   DO 65 k=1,NEIGEN
             AAA=2.*EXP(-EV(k)*EV(k)*x(I))/EV(k)/ywall(3,k)*			!For Nusselt and temperature
     *        (ywall(2,k)/2./(2.-NFLOW)+(3.+NFLOW)*(3.+NFLOW)*BR(IBR)*		!For Nusselt and temperature
     *        AINTEGR(k))							!For Nusselt and temperature
     	     SUMNUM=SUMNUM+AAA								!For Nusselt
             DO II=1,npoints+1
               SUMTET(II)=SUMTET(II)+AAA*y2(k,II)/ywall(2,k)			!for temperature
	     END DO
 65        CONTINUE
            ANUSSEL(I)=1./(AUX1+AUX2+SUMNUM)	!Nusselt final for qw=cte
	    THETAM(I)=1/ANUSSEL(I)		!Thetam
            DO II=1,npoints+1
              TETA(II,I)=AUX4(I)+AUX3(II)+AUX8(II)+SUMTET(II)
	    END DO
 60       CONTINUE
	
	
	END IF
c   End of all calculations

c   Output of final results: Nusselt numbers and temperature profiles
	WRITE(16,*)'Brinkman =',BR(IBR)
       WRITE(16,*)'I         xprime             Nusselt          THETAM
     1           Nu average     success      F(X)'
        DO I=1,NXS
	 WRITE(16,*)I,xprime(I),ANUSSEL(I),THETAM(I),ANUAVE(I),SUCC(I),
     1     FUNNU(I)
	END DO
        WRITE(16,*)


	WRITE(17,*)'Brinkman =',BR(IBR)
        DO I=1,NXS
	 WRITE(17,*)'I= ',I,'  xprime=',xprime(I),'Nu(x)=',ANUSSEL(I)
	 WRITE(17,*)
         WRITE(17,*)'II         r*               theta(r)'
	 DO II=1,npoints+1
	   WRITE(17,*)II,r(II),TETA(II,I)
	 END DO
	END DO

c   End of output of final results

 130     CONTINUE	

	CLOSE(16)
	CLOSE(17)


c   for control
c        DO k=1,NEIGEN
c         WRITE(*,*)'EV(',k,')= ',EV(k),'I1  =',AINTEGR(k)
c	END DO
c	pause

c        DO k=1,NEIGEN
c	  DO J=1,nfun
c	    WRITE(*,50)npoints+1,x(npoints+1),ywall(J,k),ywallpr(J,k)
c	  END DO
c	END DO
c	pause
	
c	DO k=1,NEIGEN
c	  DO I=1,npoints+1
c	    WRITE(*,50)I,x(I),y2(k,I)
c	  END DO
c	END DO
c	pause

c   end of control

	STOP
	
 50     FORMAT(1X,I4,3(3X,F15.11))
	
	END



	REAL*8 FUNCTION func(xnu)
        COMMON /DADOS2/ BNUM1,BDEN1,BTERM
	REAL*8 bnum,bden,y,xnu,BNUM1,BDEN1,BTERM,SMALL

	SMALL=1.0D-30
        bnum=BNUM1-xnu
	bden=BDEN1*xnu+BNUM1
c	y=BTERM-1./xnu*DLOG(bnum/bden)			!logarithmic 1 form of function
	  y=bden*DEXP(BTERM*xnu)-bnum	 		!exponential form of function
	
c	  y=BTERM*xnu-DLOG(bnum/bden)			!logarithmic 2 form of function
	func=y
	
	RETURN
	END



c	REAL*8 FUNCTION zriddr(func,x1,x2,xacc)
	REAL*8 FUNCTION zriddr(x1,x2,xacc)
	INTEGER MAXIT
	REAL*8 x1,x2,xacc,UNUSED
	PARAMETER(MAXIT=150,UNUSED=-1.1E30)
c	EXTERNAL func
c	Uses func
c	Using Ridders' method, return the root of a function func known to lie
c	between x1 and x2. The root, returned as zriddr, will be refined to an
c	approximate accuracy xacc.
	INTEGER j
	REAL*8 fh,fl,fm,fnew,s,xh,xl,xm,xnew
	fl=func(x1)
	fh=func(x2)
	if((fl.gt.0..and.fh.lt.0.).or.(fl.lt.0..and.fh.gt.0.))then
		xl = x1
		xh = x2
		zriddr = UNUSED		!Any highly unlikely value, to simplify logic below.
		do 11 j=1,MAXIT
			xm = 0.5*(xl + xh)
			fm = func(xm)	!First of two function evaluations per iteration
			s = sqrt(fm**2-fl*fh)
			if(s .eq. 0)return
			xnew=xm+(xm-xl)*(sign(1.,fl-fh)*fm/s)	!Updating formula
			if (abs(xnew-zriddr) .le. xacc) return
			zriddr = xnew
			fnew = func(zriddr)	!Second of two function evaluations per iteration.
			if (fnew .eq. 0.) return
			if (sign(fm,fnew) .ne. fm)then	!Bookkeeping to keep the root bracketed
c											 on next iteration.
				xl = xm
				fl = fm
				xh = zriddr
				fh = fnew
			else if(sign(fl,fnew) .ne. fl) then
				xh = zriddr
				fh = fnew
			else if(sign(fh,fnew) .ne. fh) then
				xl = zriddr
				fl = fnew
			else
				write(16,*)'never get here in zriddr'
				stop
			end if
			if (abs(xh-xl) .le. xacc) return
 11		continue
		write(16,*) 'zriddr exceed maximum iterations'
		stop
	else if (fl .eq. 0.) then
		zriddr = x1
	else if (fh .eq. 0.) then
		zriddr = x2
	else
		write(16,*)'root must be bracketed in zriddr'
	end if
	return
	END



	REAL*8 FUNCTION rtbis(x1,x2,xacc)
	INTEGER JMAX
	REAL*8 x1,x2,xacc
c	EXTERNAL func
	PARAMETER(JMAX=400)		!Maximum allowed number of bisections
c	Using bisection, find the root of a function func known to lie between x1 and
c	x2. The root, returned as rtbis, will be refined until its accuracy is xacc.
	INTEGER j
	REAL*8 dx,f,fmid,xmid
	fmid=func(x2)
	f=func(x1)
	if(f*fmid .ge. 0.) then
		write(16,*)'root must be bracketed in rtbis'
		return
c		stop
	end if
	if(f .lt. 0.) then	!Orient the search so that f>0 lies at x+dx
		rtbis=x1
		dx=x2-x1
	else
		rtbis=x2
		dx=x1-x2
	end if
	do 11 j=1,JMAX		!Bisection loop
		dx = dx*0.5
		xmid=rtbis + dx
		fmid=func(xmid)
		if(fmid .le. 0.) rtbis=xmid
		if(abs(dx) .lt. xacc .or. fmid .eq. 0.) return
 11	continue
	write(16,*)'too many bisections in rtbis'
	return
c	stop
	END




c	REAL*8 FUNCTION rtflsp(func,x1,x2,xacc)
	REAL*8 FUNCTION rtflsp(x1,x2,xacc)
	INTEGER MAXIT
	REAL*8 x1,x2,xacc
c	EXTERNAL func
	PARAMETER (MAXIT=30)		!Set the maximum allowed number of iterations.
c	Using the false position method, find the root of a function func known
c	to lie between x1 and x2. The root, returned as rtflsp, is refined until
c	its accuracy is xacc.
	INTEGER j
	REAL*8 del,dx,f,fh,fl,swap,xh,xl
	fl = func(x1)
	fh = func(x2)		!Be sure the interval brackets a root.
	if(fl*fh .gt. 0.) then
		write(16,*)'root must be bracketed in rtflsp'
		return
c		stop
	end if
	if (fl .lt. 0.) then	!Identify the limits so that x1 corresponds to the low side
		xl = x1
		xh = x2
	else
		xl = x2
		xh = x1
		swap = fl
		fl = fh
		fh = swap
	end if
	dx = xh - xl
	do 11 j=1,MAXIT		!False position loop
		rtflsp=xl+dx*fl/(fl-fh)		!Increment with respect to latest value
		f = func(rtflsp)
		if (f .lt. 0.) then		!Replace appropriate limit
			del = xl - rtflsp
			xl = rtflsp
			fl = f
		else
			del = xh - rtflsp
			xh = rtflsp
			fh = f
		end if
		dx = xh - xl
		if (abs(del) .lt. xacc .or. f .eq. 0. )return	!Convergence
 11	continue
	write(16,*) 'rtflsp exceed maximum iterations'
	return
c	stop
	END

c	SUBROUTINE zbrac(func,x1,x2,succes)
	SUBROUTINE zbrac(x1,x2,succes)
	INTEGER NTRY
	REAL*8 x1,x2,func,FACTOR
c	EXTERNAL func
	PARAMETER(FACTOR=1.05,NTRY=1000)
c	Given a function func and an initial guessed range x1 to x2, the routine
c	expands the range geometrically until a root is bracketed by the returned
c	values x1 and x2(in which case succes returns as .true.) or until the range
c	becomes unacceptably large (in which case succes returns as .false.)
	INTEGER j
	REAL*8 f1,f2
	LOGICAL succes
	if(x1 .eq. x2) then
		write(*,*) 'you have to guess an initial range in zbrac'
		stop
	end if
	f1 = func(x1)
	f2 = func(x2)
	succes= .true.
	do 11 j=1,NTRY
		if(f1*f2 .lt. 0) return
		if(abs(f1) .lt. abs(f2)) then
			x1=x1+FACTOR*(x1-x2)
			f1=func(x1)
		else
			x2=x2+FACTOR*(x2-x1)
			f2=func(x2)
		end if
 11	continue
	succes=.false.
	return
	END

c	SUBROUTINE myzbrac(func,x1,x2,succes)
	SUBROUTINE myzbrac(x1,x2,succes)
	INTEGER NTRY
	REAL*8 x1,x2,func,FACTOR,x3
c	EXTERNAL func
	PARAMETER(FACTOR=1.10,NTRY=1000)
c	Given a function func and an initial guessed range x1 to x2, the routine
c	expands the range geometrically only on the side of x2 until it brackets a zero
c	at values x1 and x2(in which case succes returns as .true.) or until the range
c	becomes unacceptably large (in which case succes returns as .false.)
	INTEGER j
	REAL*8 f1,f2
	LOGICAL succes
	if(x1 .eq. x2) then
		write(*,*) 'you have to guess an initial range in zbrac'
		stop
	end if
	f1 = func(x1)
	f2 = func(x2)
	succes= .true.
	do 11 j=1,NTRY
		if(f1*f2 .lt. 0) return
                if(abs(f2) .lt. abs(f1)) then
c			x3=x2
			x2=x2+FACTOR*(x2-x1)
c			x1=x3
c			f1 = func(x1)
			f2=func(x2)
		end if

 11	continue
	succes=.false.
	return
	END
